/*
 * CLDACommand.h
 *
 *  Created on: May 24, 2010
 *      Author: pdas
 */

#ifndef CLDACOMMAND_H_
#define CLDACOMMAND_H_

#include "../include/includes.h"
#include "../SamplingAlgorithms/CModelSamplingFunctionoid.h"
#include "../SamplingAlgorithms/CLDASamplingFunctionoid.h"
#include "../GraphicalModels/CLDAGeneralModel.h"
#include "CCommand.h"
//using namespace std;

class CLDACommand : public CCommand {
	CModelSamplingFunctionoid* _sampling_model;
	std::vector<std::string> _command_args;

public:
	CLDACommand();
	virtual ~CLDACommand();
	virtual CLDAGeneralModel* get_model() { return _sampling_model->get_concrete_model(); }

	virtual void execute();
	virtual void set_model_bytecode(std::string bytecode) { CCommand::_model_bytecode = bytecode; }
	virtual void set_arguments(std::vector<std::string>& args);

};

#endif /* CLDACOMMAND_H_ */
