/*
 * CLDACommandHandler.cpp
 *
 *  Created on: May 24, 2010
 *      Author: pdas
 */

#include "CLDACommandHandler.h"

using namespace std;

CLDACommandHandler::CLDACommandHandler() {
	_command = new CLDACommand();
}

CLDACommandHandler::~CLDACommandHandler() {
	delete _command;
}

/**
 * This function can set the parameters of the command if needed i.e. simulates CLI (Command Line Interface)
 */
void CLDACommandHandler::set_arguments(vector<string>& command_args) {
	_command_args = command_args;
}

/**
 * This functions handles a concrete command which is passed in the parameter through a pointer to the command's base class
 */
void CLDACommandHandler::handle_command() {

	if ( _command_args.size() != 0 )
		_command->set_arguments(_command_args);

	_command->execute();
}
