/*
 * CLDASamplingFunctionoid.h
 *
 *  Created on: May 21, 2010
 *      Author: pdas
 */

#ifndef CLDASAMPLINGFUNCTIONOID_H_
#define CLDASAMPLINGFUNCTIONOID_H_

#include "CModelSamplingFunctionoid.h"
#include "../GraphicalModels/CLDAGeneralModel.h"
#include "../GraphicalModels/CLDAGibbs.h"

class CLDAGibbs;

class CLDASamplingFunctionoid : public CModelSamplingFunctionoid {

	CLDAGibbs* _concrete_model;
	CLDAGeneralModel* _base_model;

	std::vector<double> _prob_density_vec;

public:
	CLDASamplingFunctionoid();
	~CLDASamplingFunctionoid();
	inline CLDAGeneralModel* get_concrete_model() { return _base_model; }

	inline void operator()();

	double get_final_model_log_likelihood() { return _likelihood; }

private:
	double _likelihood;

	// compute the imputation step
	void imputation_step();
	// compute the posterior step
	void posterior_step();

	void resample_z_train();		// resampling Z (M x N_{M}) matrix in one shot
	void resample_beta_train();		// K x V topic parameter matrix
	void resample_theta_train();	// M x K topic proportion matrix
	void resample_alpha();			// prior for M x K theta
	void resample_eta();			// prior for K x V beta

	void resample_z_test();			// resampling Z (M x N_{M}) matrix in one shot
	void resample_beta_test();		// K x V topic parameter matrix
	void resample_theta_test();		// M x K topic proportion matrix

};

#endif /* CLDASAMPLINGFUNCTIONOID_H_ */
